=== ecere/Makefile ===
.PHONY: objdir clean cleantarget realclean distclean nores

# CONTENT

MODULE := ecere
CONFIG := release
COMPILER := default
TARGET_TYPE = sharedlib

OBJ = obj/$(CONFIG).$(PLATFORM)/

RES = res/

ifndef DEBIAN_PACKAGE
CFLAGS =
endif
OFLAGS =

# CROSS-PLATFORM MAGIC

include ../include.mk

ifdef LINUX
TARGET = obj/$(CONFIG).$(PLATFORM)/$(LP)$(MODULE)$(SO).0.44
SONAME = -Wl,-soname,libecere.so.0
else
TARGET = obj/$(CONFIG).$(PLATFORM)/$(LP)$(MODULE)$(SO)
SONAME =
endif

OBJECTS = $(OBJECTS1) $(OBJECTS2) $(OBJECTS3) $(OBJECTS4)
OBJECTS1 = \
	$(OBJ)Archive.o \
	$(OBJ)BufferedFile.o \
	$(OBJ)Date.o \
	$(OBJ)DualPipe.o \
	$(OBJ)EARArchive.o \
	$(OBJ)File.o \
	$(OBJ)FileMonitor.o \
	$(OBJ)GlobalAppSettings.o \
	$(OBJ)JSON.o \
	$(OBJ)JSONGlobalSettings.o \
	$(OBJ)memory.o \
	$(OBJ)Mutex.o \
	$(OBJ)Semaphore.o \
	$(OBJ)System.o \
	$(OBJ)TempFile.o \
	$(OBJ)Thread.o \
	$(OBJ)Time.o \
	$(OBJ)unicode.o \
	$(OBJ)units.o \
	$(OBJ)File.c.o \
	$(OBJ)DualPipe.c.o \
	$(OBJ)System.c.o \
	$(OBJ)i18n.o \
	$(OBJ)Cube.o \
	$(OBJ)SkyBox.o \
	$(OBJ)Sphere.o \
	$(OBJ)Object3DSFormat.o \
	$(OBJ)Camera.o \
	$(OBJ)Matrix.o \
	$(OBJ)Mesh.o \
	$(OBJ)Object.o \
	$(OBJ)Plane.o \
	$(OBJ)Quaternion.o \
	$(OBJ)Vector3D.o \
	$(OBJ)BMPFormat.o \
	$(OBJ)GIFFormat.o \
	$(OBJ)JPEGFormat.o \
	$(OBJ)PCXFormat.o \
	$(OBJ)PNGFormat.o \
	$(OBJ)RGBFormat.o \
	$(OBJ)harfbuzz-freetype.o \
	$(OBJ)harfbuzz-unicode-tables.o \
	$(OBJ)harfbuzz-unicode.o \
	$(OBJ)harfbuzz-arabic.o \
	$(OBJ)harfbuzz-buffer.o \
	$(OBJ)harfbuzz-gdef.o \
	$(OBJ)harfbuzz-gpos.o \
	$(OBJ)harfbuzz-gsub.o \
	$(OBJ)harfbuzz-hangul.o
OBJECTS2 = \
	$(OBJ)harfbuzz-hebrew.o \
	$(OBJ)harfbuzz-indic.o \
	$(OBJ)harfbuzz-khmer.o \
	$(OBJ)harfbuzz-myanmar.o \
	$(OBJ)harfbuzz-open.o \
	$(OBJ)harfbuzz-shaper.o \
	$(OBJ)harfbuzz-stream.o \
	$(OBJ)harfbuzz-tibetan.o \
	$(OBJ)harfbuzz-impl.o \
	$(OBJ)harfbuzz-thai.o \
	$(if $(WINDOWS),$(OBJ)Direct3D8DisplayDriver.o,) \
	$(if $(WINDOWS),$(OBJ)Direct3D9DisplayDriver.o,) \
	$(if $(WINDOWS),$(OBJ)DirectDrawDisplayDriver.o,) \
	$(if $(WINDOWS),$(OBJ)GDIDisplayDriver.o,) \
	$(OBJ)lfbBlit.o \
	$(OBJ)lfbConvert.o \
	$(OBJ)LFBDisplayDriver.o \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)NCursesDisplayDriver.o,) \
	$(if $(OSX),,$(OBJ)OpenGLDisplayDriver.o) \
	$(if $(WINDOWS),$(OBJ)Win32BitmapPrinterDisplayDriver.o,) \
	$(if $(OSX),$(OBJ)CocoaOpenGLDisplayDriver.o,) \
	$(if $(WINDOWS),$(OBJ)Win32ConsoleDisplayDriver.o,) \
	$(if $(WINDOWS),$(OBJ)Win32PrinterDisplayDriver.o,) \
	$(if $(LINUX),$(OBJ)XDisplayDriver.o,) \
	$(OBJ)Bitmap.o \
	$(OBJ)BitmapResource.o \
	$(OBJ)Color.o \
	$(OBJ)Display.o \
	$(OBJ)DisplaySystem.o \
	$(OBJ)FontResource.o \
	$(OBJ)Resource.o \
	$(OBJ)Surface.o \
	$(OBJ)Button.o \
	$(OBJ)CalendarControl.o \
	$(OBJ)DataBox.o
OBJECTS3 = \
	$(OBJ)DropBox.o \
	$(OBJ)EditBox.o \
	$(OBJ)Label.o \
	$(OBJ)ListBox.o \
	$(OBJ)Menu.o \
	$(OBJ)Picture.o \
	$(OBJ)ProgressBar.o \
	$(OBJ)ScrollBar.o \
	$(OBJ)StatusBar.o \
	$(OBJ)TabControl.o \
	$(OBJ)PaneSplitter.o \
	$(OBJ)Stacker.o \
	$(OBJ)PathBox.o \
	$(OBJ)ToolTip.o \
	$(OBJ)SelectorBar.o \
	$(OBJ)ColorPicker.o \
	$(OBJ)FileDialog.o \
	$(OBJ)FindDialog.o \
	$(OBJ)GoToDialog.o \
	$(OBJ)MessageBox.o \
	$(OBJ)ReplaceDialog.o \
	$(OBJ)WindowList.o \
	$(if $(OSX),$(OBJ)CocoaDispatch.o,) \
	$(if $(OSX),$(OBJ)CocoaEcereBridge.o,) \
	$(if $(OSX),$(OBJ)CocoaInterface.o,) \
	$(if $(OSX),$(OBJ)EcereView.o,) \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)NCursesInterface.o,) \
	$(if $(WINDOWS),$(OBJ)Win32Interface.o,) \
	$(if $(WINDOWS),$(OBJ)Win32ConsoleInterface.o,) \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)XInterface.o,) \
	$(OBJ)TVisionSkin.o \
	$(OBJ)WindowsSkin.o \
	$(OBJ)Anchor.o \
	$(OBJ)ClipBoard.o \
	$(OBJ)Cursor.o \
	$(OBJ)Desktop3D.o \
	$(OBJ)FormDesigner.o \
	$(OBJ)GuiApplication.o \
	$(OBJ)Interface.o \
	$(OBJ)Key.o \
	$(OBJ)Skin.o \
	$(OBJ)Timer.o
OBJECTS4 = \
	$(OBJ)typeEdit.o \
	$(OBJ)Window.o \
	$(OBJ)dcom.o \
	$(OBJ)HTTPFile.o \
	$(OBJ)network.o \
	$(OBJ)NetworkClientFile.o \
	$(OBJ)Service.o \
	$(OBJ)Socket.o \
	$(OBJ)Array.o \
	$(OBJ)AVLTree.o \
	$(OBJ)BuiltInContainer.o \
	$(OBJ)Container.o \
	$(OBJ)CustomAVLTree.o \
	$(OBJ)LinkList.o \
	$(OBJ)List.o \
	$(OBJ)Map.o \
	$(OBJ)BinaryTree.o \
	$(OBJ)BTNode.o \
	$(OBJ)dataTypes.o \
	$(OBJ)instance.o \
	$(OBJ)String.o \
	$(OBJ)OldList.o \
	$(OBJ)instance.c.o \
	$(OBJ)$(MODULE).main$(O)

COBJECTS = $(COBJECTS1) $(COBJECTS2) $(COBJECTS3)
COBJECTS1 = \
	$(OBJ)Archive.c \
	$(OBJ)BufferedFile.c \
	$(OBJ)Date.c \
	$(OBJ)DualPipe.c \
	$(OBJ)EARArchive.c \
	$(OBJ)File.c \
	$(OBJ)FileMonitor.c \
	$(OBJ)GlobalAppSettings.c \
	$(OBJ)JSON.c \
	$(OBJ)JSONGlobalSettings.c \
	$(OBJ)memory.c \
	$(OBJ)Mutex.c \
	$(OBJ)Semaphore.c \
	$(OBJ)System.c \
	$(OBJ)TempFile.c \
	$(OBJ)Thread.c \
	$(OBJ)Time.c \
	$(OBJ)unicode.c \
	$(OBJ)units.c \
	$(OBJ)i18n.c \
	$(OBJ)Cube.c \
	$(OBJ)SkyBox.c \
	$(OBJ)Sphere.c \
	$(OBJ)Object3DSFormat.c \
	$(OBJ)Camera.c \
	$(OBJ)Matrix.c \
	$(OBJ)Mesh.c \
	$(OBJ)Object.c \
	$(OBJ)Plane.c \
	$(OBJ)Quaternion.c \
	$(OBJ)Vector3D.c \
	$(OBJ)BMPFormat.c \
	$(OBJ)GIFFormat.c \
	$(OBJ)JPEGFormat.c \
	$(OBJ)PCXFormat.c \
	$(OBJ)PNGFormat.c \
	$(OBJ)RGBFormat.c \
	$(if $(WINDOWS),$(OBJ)Direct3D8DisplayDriver.c,) \
	$(if $(WINDOWS),$(OBJ)Direct3D9DisplayDriver.c,) \
	$(if $(WINDOWS),$(OBJ)DirectDrawDisplayDriver.c,) \
	$(if $(WINDOWS),$(OBJ)GDIDisplayDriver.c,) \
	$(OBJ)lfbBlit.c \
	$(OBJ)lfbConvert.c \
	$(OBJ)LFBDisplayDriver.c \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)NCursesDisplayDriver.c,)
COBJECTS2 = \
	$(if $(OSX),,$(OBJ)OpenGLDisplayDriver.c) \
	$(if $(WINDOWS),$(OBJ)Win32BitmapPrinterDisplayDriver.c,) \
	$(if $(OSX),$(OBJ)CocoaOpenGLDisplayDriver.c,) \
	$(if $(WINDOWS),$(OBJ)Win32ConsoleDisplayDriver.c,) \
	$(if $(WINDOWS),$(OBJ)Win32PrinterDisplayDriver.c,) \
	$(if $(LINUX),$(OBJ)XDisplayDriver.c,) \
	$(OBJ)Bitmap.c \
	$(OBJ)BitmapResource.c \
	$(OBJ)Color.c \
	$(OBJ)Display.c \
	$(OBJ)DisplaySystem.c \
	$(OBJ)FontResource.c \
	$(OBJ)Resource.c \
	$(OBJ)Surface.c \
	$(OBJ)Button.c \
	$(OBJ)CalendarControl.c \
	$(OBJ)DataBox.c \
	$(OBJ)DropBox.c \
	$(OBJ)EditBox.c \
	$(OBJ)Label.c \
	$(OBJ)ListBox.c \
	$(OBJ)Menu.c \
	$(OBJ)Picture.c \
	$(OBJ)ProgressBar.c \
	$(OBJ)ScrollBar.c \
	$(OBJ)StatusBar.c \
	$(OBJ)TabControl.c \
	$(OBJ)PaneSplitter.c \
	$(OBJ)Stacker.c \
	$(OBJ)PathBox.c \
	$(OBJ)ToolTip.c \
	$(OBJ)SelectorBar.c \
	$(OBJ)ColorPicker.c \
	$(OBJ)FileDialog.c \
	$(OBJ)FindDialog.c \
	$(OBJ)GoToDialog.c \
	$(OBJ)MessageBox.c \
	$(OBJ)ReplaceDialog.c \
	$(OBJ)WindowList.c \
	$(if $(OSX),$(OBJ)CocoaDispatch.c,)
COBJECTS3 = \
	$(if $(OSX),$(OBJ)CocoaInterface.c,) \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)NCursesInterface.c,) \
	$(if $(WINDOWS),$(OBJ)Win32Interface.c,) \
	$(if $(WINDOWS),$(OBJ)Win32ConsoleInterface.c,) \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)XInterface.c,) \
	$(OBJ)TVisionSkin.c \
	$(OBJ)WindowsSkin.c \
	$(OBJ)Anchor.c \
	$(OBJ)ClipBoard.c \
	$(OBJ)Cursor.c \
	$(OBJ)Desktop3D.c \
	$(OBJ)FormDesigner.c \
	$(OBJ)GuiApplication.c \
	$(OBJ)Interface.c \
	$(OBJ)Key.c \
	$(OBJ)Skin.c \
	$(OBJ)Timer.c \
	$(OBJ)typeEdit.c \
	$(OBJ)Window.c \
	$(OBJ)dcom.c \
	$(OBJ)HTTPFile.c \
	$(OBJ)network.c \
	$(OBJ)NetworkClientFile.c \
	$(OBJ)Service.c \
	$(OBJ)Socket.c \
	$(OBJ)Array.c \
	$(OBJ)AVLTree.c \
	$(OBJ)BuiltInContainer.c \
	$(OBJ)Container.c \
	$(OBJ)CustomAVLTree.c \
	$(OBJ)LinkList.c \
	$(OBJ)List.c \
	$(OBJ)Map.c \
	$(OBJ)BinaryTree.c \
	$(OBJ)BTNode.c \
	$(OBJ)dataTypes.c \
	$(OBJ)instance.c \
	$(OBJ)String.c \
	$(OBJ)OldList.c

SYMBOLS = $(SYMBOLS1) $(SYMBOLS2) $(SYMBOLS3) $(SYMBOLS4)
SYMBOLS1 = \
	$(OBJ)Archive.sym \
	$(OBJ)BufferedFile.sym \
	$(OBJ)Date.sym \
	$(OBJ)DualPipe.sym \
	$(OBJ)EARArchive.sym \
	$(OBJ)File.sym \
	$(OBJ)FileMonitor.sym \
	$(OBJ)GlobalAppSettings.sym \
	$(OBJ)JSON.sym \
	$(OBJ)JSONGlobalSettings.sym \
	$(OBJ)memory.sym \
	$(OBJ)Mutex.sym \
	$(OBJ)Semaphore.sym \
	$(OBJ)System.sym \
	$(OBJ)TempFile.sym \
	$(OBJ)Thread.sym \
	$(OBJ)Time.sym \
	$(OBJ)unicode.sym \
	$(OBJ)units.sym \
	$(OBJ)i18n.sym \
	$(OBJ)Cube.sym \
	$(OBJ)SkyBox.sym \
	$(OBJ)Sphere.sym \
	$(OBJ)Object3DSFormat.sym \
	$(OBJ)Camera.sym \
	$(OBJ)Matrix.sym \
	$(OBJ)Mesh.sym \
	$(OBJ)Object.sym \
	$(OBJ)Plane.sym \
	$(OBJ)Quaternion.sym \
	$(OBJ)Vector3D.sym \
	$(OBJ)BMPFormat.sym \
	$(OBJ)GIFFormat.sym \
	$(OBJ)JPEGFormat.sym \
	$(OBJ)PCXFormat.sym \
	$(OBJ)PNGFormat.sym \
	$(OBJ)RGBFormat.sym \
	$(if $(WINDOWS),$(OBJ)Direct3D8DisplayDriver.sym,) \
	$(if $(WINDOWS),$(OBJ)Direct3D9DisplayDriver.sym,) \
	$(if $(WINDOWS),$(OBJ)DirectDrawDisplayDriver.sym,) \
	$(if $(WINDOWS),$(OBJ)GDIDisplayDriver.sym,) \
	$(OBJ)lfbBlit.sym \
	$(OBJ)lfbConvert.sym \
	$(OBJ)LFBDisplayDriver.sym
SYMBOLS2 = \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)NCursesDisplayDriver.sym,) \
	$(if $(OSX),,$(OBJ)OpenGLDisplayDriver.sym) \
	$(if $(WINDOWS),$(OBJ)Win32BitmapPrinterDisplayDriver.sym,) \
	$(if $(OSX),$(OBJ)CocoaOpenGLDisplayDriver.sym,) \
	$(if $(WINDOWS),$(OBJ)Win32ConsoleDisplayDriver.sym,) \
	$(if $(WINDOWS),$(OBJ)Win32PrinterDisplayDriver.sym,) \
	$(if $(LINUX),$(OBJ)XDisplayDriver.sym,) \
	$(OBJ)Bitmap.sym \
	$(OBJ)BitmapResource.sym \
	$(OBJ)Color.sym \
	$(OBJ)Display.sym \
	$(OBJ)DisplaySystem.sym \
	$(OBJ)FontResource.sym \
	$(OBJ)Resource.sym \
	$(OBJ)Surface.sym \
	$(OBJ)Button.sym \
	$(OBJ)CalendarControl.sym \
	$(OBJ)DataBox.sym \
	$(OBJ)DropBox.sym \
	$(OBJ)EditBox.sym \
	$(OBJ)Label.sym \
	$(OBJ)ListBox.sym \
	$(OBJ)Menu.sym \
	$(OBJ)Picture.sym \
	$(OBJ)ProgressBar.sym \
	$(OBJ)ScrollBar.sym \
	$(OBJ)StatusBar.sym \
	$(OBJ)TabControl.sym \
	$(OBJ)PaneSplitter.sym \
	$(OBJ)Stacker.sym \
	$(OBJ)PathBox.sym \
	$(OBJ)ToolTip.sym \
	$(OBJ)SelectorBar.sym \
	$(OBJ)ColorPicker.sym \
	$(OBJ)FileDialog.sym \
	$(OBJ)FindDialog.sym \
	$(OBJ)GoToDialog.sym
SYMBOLS3 = \
	$(OBJ)MessageBox.sym \
	$(OBJ)ReplaceDialog.sym \
	$(OBJ)WindowList.sym \
	$(if $(OSX),$(OBJ)CocoaDispatch.sym,) \
	$(if $(OSX),$(OBJ)CocoaInterface.sym,) \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)NCursesInterface.sym,) \
	$(if $(WINDOWS),$(OBJ)Win32Interface.sym,) \
	$(if $(WINDOWS),$(OBJ)Win32ConsoleInterface.sym,) \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)XInterface.sym,) \
	$(OBJ)TVisionSkin.sym \
	$(OBJ)WindowsSkin.sym \
	$(OBJ)Anchor.sym \
	$(OBJ)ClipBoard.sym \
	$(OBJ)Cursor.sym \
	$(OBJ)Desktop3D.sym \
	$(OBJ)FormDesigner.sym \
	$(OBJ)GuiApplication.sym \
	$(OBJ)Interface.sym \
	$(OBJ)Key.sym \
	$(OBJ)Skin.sym \
	$(OBJ)Timer.sym \
	$(OBJ)typeEdit.sym \
	$(OBJ)Window.sym \
	$(OBJ)dcom.sym \
	$(OBJ)HTTPFile.sym \
	$(OBJ)network.sym \
	$(OBJ)NetworkClientFile.sym \
	$(OBJ)Service.sym \
	$(OBJ)Socket.sym \
	$(OBJ)Array.sym \
	$(OBJ)AVLTree.sym \
	$(OBJ)BuiltInContainer.sym \
	$(OBJ)Container.sym \
	$(OBJ)CustomAVLTree.sym \
	$(OBJ)LinkList.sym \
	$(OBJ)List.sym \
	$(OBJ)Map.sym \
	$(OBJ)BinaryTree.sym \
	$(OBJ)BTNode.sym \
	$(OBJ)dataTypes.sym \
	$(OBJ)instance.sym
SYMBOLS4 = \
	$(OBJ)String.sym \
	$(OBJ)OldList.sym

IMPORTS = $(IMPORTS1) $(IMPORTS2) $(IMPORTS3) $(IMPORTS4)
IMPORTS1 = \
	$(OBJ)Archive.imp \
	$(OBJ)BufferedFile.imp \
	$(OBJ)Date.imp \
	$(OBJ)DualPipe.imp \
	$(OBJ)EARArchive.imp \
	$(OBJ)File.imp \
	$(OBJ)FileMonitor.imp \
	$(OBJ)GlobalAppSettings.imp \
	$(OBJ)JSON.imp \
	$(OBJ)JSONGlobalSettings.imp \
	$(OBJ)memory.imp \
	$(OBJ)Mutex.imp \
	$(OBJ)Semaphore.imp \
	$(OBJ)System.imp \
	$(OBJ)TempFile.imp \
	$(OBJ)Thread.imp \
	$(OBJ)Time.imp \
	$(OBJ)unicode.imp \
	$(OBJ)units.imp \
	$(OBJ)i18n.imp \
	$(OBJ)Cube.imp \
	$(OBJ)SkyBox.imp \
	$(OBJ)Sphere.imp \
	$(OBJ)Object3DSFormat.imp \
	$(OBJ)Camera.imp \
	$(OBJ)Matrix.imp \
	$(OBJ)Mesh.imp \
	$(OBJ)Object.imp \
	$(OBJ)Plane.imp \
	$(OBJ)Quaternion.imp \
	$(OBJ)Vector3D.imp \
	$(OBJ)BMPFormat.imp \
	$(OBJ)GIFFormat.imp \
	$(OBJ)JPEGFormat.imp \
	$(OBJ)PCXFormat.imp \
	$(OBJ)PNGFormat.imp \
	$(OBJ)RGBFormat.imp \
	$(if $(WINDOWS),$(OBJ)Direct3D8DisplayDriver.imp,) \
	$(if $(WINDOWS),$(OBJ)Direct3D9DisplayDriver.imp,) \
	$(if $(WINDOWS),$(OBJ)DirectDrawDisplayDriver.imp,) \
	$(if $(WINDOWS),$(OBJ)GDIDisplayDriver.imp,) \
	$(OBJ)lfbBlit.imp \
	$(OBJ)lfbConvert.imp \
	$(OBJ)LFBDisplayDriver.imp
IMPORTS2 = \
