=== ide/Makefile ===
.PHONY: all objdir clean realclean distclean

# CONTENT

MODULE := ide
CONFIG := release
COMPILER := default
TARGET_TYPE = executable

OBJ = obj/$(CONFIG).$(PLATFORM)/

RES = res/

CONSOLE = -mwindows

TARGET = obj/$(CONFIG).$(PLATFORM)/ide$(E)

OBJECTS = \
	$(OBJ)FileSystemIterator.o \
	$(OBJ)layout.o \
	$(OBJ)StringsBox.o \
	$(OBJ)ActiveCompilerDialog.o \
	$(OBJ)CompilersDetectionDialog.o \
	$(OBJ)FindInFilesDialog.o \
	$(OBJ)GlobalSettingsDialog.o \
	$(OBJ)NewProjectDialog.o \
	$(OBJ)NodeProperties.o \
	$(OBJ)ProjectActiveConfig.o \
	$(OBJ)WorkspaceSettings.o \
	$(OBJ)ProjectTabSettings.o \
	$(OBJ)Project.o \
	$(OBJ)ProjectConfig.o \
	$(OBJ)ProjectNode.o \
	$(OBJ)ProjectView.o \
	$(OBJ)Workspace.o \
	$(if $(WINDOWS),$(OBJ)vsSupport.o,) \
	$(OBJ)CodeEditor.o \
	$(OBJ)CodeObject.o \
	$(OBJ)Designer.o \
	$(OBJ)findCtx.o \
	$(OBJ)findExp.o \
	$(OBJ)findParams.o \
	$(OBJ)Sheet.o \
	$(OBJ)ToolBox.o \
	$(OBJ)debugFindCtx.o \
	$(OBJ)Debugger.o \
	$(OBJ)debugTools.o \
	$(OBJ)GDBDialog.o \
	$(OBJ)process.o \
	$(OBJ)BreakpointsView.o \
	$(OBJ)CallStackView.o \
	$(OBJ)OutputView.o \
	$(OBJ)ThreadsView.o \
	$(OBJ)WatchesView.o \
	$(OBJ)ModelView.o \
	$(OBJ)PictureEdit.o \
	$(OBJ)about.o \
	$(OBJ)ide.o \
	$(OBJ)IDESettings.o \
	$(OBJ)OldIDESettings.o \
	$(OBJ)ProjectSettings.o \
	$(OBJ)licensing.o \
	$(OBJ)$(MODULE).main$(O)

COBJECTS = \
	$(OBJ)FileSystemIterator.c \
	$(OBJ)layout.c \
	$(OBJ)StringsBox.c \
	$(OBJ)ActiveCompilerDialog.c \
	$(OBJ)CompilersDetectionDialog.c \
	$(OBJ)FindInFilesDialog.c \
	$(OBJ)GlobalSettingsDialog.c \
	$(OBJ)NewProjectDialog.c \
	$(OBJ)NodeProperties.c \
	$(OBJ)ProjectActiveConfig.c \
	$(OBJ)WorkspaceSettings.c \
	$(OBJ)ProjectTabSettings.c \
	$(OBJ)Project.c \
	$(OBJ)ProjectConfig.c \
	$(OBJ)ProjectNode.c \
	$(OBJ)ProjectView.c \
	$(OBJ)Workspace.c \
	$(if $(WINDOWS),$(OBJ)vsSupport.c,) \
	$(OBJ)CodeEditor.c \
	$(OBJ)CodeObject.c \
	$(OBJ)Designer.c \
	$(OBJ)findCtx.c \
	$(OBJ)findExp.c \
	$(OBJ)findParams.c \
	$(OBJ)Sheet.c \
	$(OBJ)ToolBox.c \
	$(OBJ)debugFindCtx.c \
	$(OBJ)Debugger.c \
	$(OBJ)debugTools.c \
	$(OBJ)GDBDialog.c \
	$(OBJ)process.c \
	$(OBJ)BreakpointsView.c \
	$(OBJ)CallStackView.c \
	$(OBJ)OutputView.c \
	$(OBJ)ThreadsView.c \
	$(OBJ)WatchesView.c \
	$(OBJ)ModelView.c \
	$(OBJ)PictureEdit.c \
	$(OBJ)about.c \
	$(OBJ)ide.c \
	$(OBJ)IDESettings.c \
	$(OBJ)OldIDESettings.c \
	$(OBJ)ProjectSettings.c \
	$(OBJ)licensing.c

SYMBOLS = $(SYMBOLS1) $(SYMBOLS2)
SYMBOLS1 = \
	$(OBJ)FileSystemIterator.sym \
	$(OBJ)layout.sym \
	$(OBJ)StringsBox.sym \
	$(OBJ)ActiveCompilerDialog.sym \
	$(OBJ)CompilersDetectionDialog.sym \
	$(OBJ)FindInFilesDialog.sym \
	$(OBJ)GlobalSettingsDialog.sym \
	$(OBJ)NewProjectDialog.sym \
	$(OBJ)NodeProperties.sym \
	$(OBJ)ProjectActiveConfig.sym \
	$(OBJ)WorkspaceSettings.sym \
	$(OBJ)ProjectTabSettings.sym \
	$(OBJ)Project.sym \
	$(OBJ)ProjectConfig.sym \
	$(OBJ)ProjectNode.sym \
	$(OBJ)ProjectView.sym \
	$(OBJ)Workspace.sym \
	$(if $(WINDOWS),$(OBJ)vsSupport.sym,) \
	$(OBJ)CodeEditor.sym \
	$(OBJ)CodeObject.sym \
	$(OBJ)Designer.sym \
	$(OBJ)findCtx.sym \
	$(OBJ)findExp.sym \
	$(OBJ)findParams.sym \
	$(OBJ)Sheet.sym \
	$(OBJ)ToolBox.sym \
	$(OBJ)debugFindCtx.sym \
	$(OBJ)Debugger.sym \
	$(OBJ)debugTools.sym \
	$(OBJ)GDBDialog.sym \
	$(OBJ)process.sym \
	$(OBJ)BreakpointsView.sym \
	$(OBJ)CallStackView.sym \
	$(OBJ)OutputView.sym \
	$(OBJ)ThreadsView.sym \
	$(OBJ)WatchesView.sym \
	$(OBJ)ModelView.sym \
	$(OBJ)PictureEdit.sym \
	$(OBJ)about.sym \
	$(OBJ)ide.sym \
	$(OBJ)IDESettings.sym \
	$(OBJ)OldIDESettings.sym
SYMBOLS2 = \
	$(OBJ)ProjectSettings.sym \
	$(OBJ)licensing.sym

IMPORTS = $(IMPORTS1) $(IMPORTS2)
IMPORTS1 = \
	$(OBJ)FileSystemIterator.imp \
	$(OBJ)layout.imp \
	$(OBJ)StringsBox.imp \
	$(OBJ)ActiveCompilerDialog.imp \
	$(OBJ)CompilersDetectionDialog.imp \
	$(OBJ)FindInFilesDialog.imp \
	$(OBJ)GlobalSettingsDialog.imp \
	$(OBJ)NewProjectDialog.imp \
	$(OBJ)NodeProperties.imp \
	$(OBJ)ProjectActiveConfig.imp \
	$(OBJ)WorkspaceSettings.imp \
	$(OBJ)ProjectTabSettings.imp \
	$(OBJ)Project.imp \
	$(OBJ)ProjectConfig.imp \
	$(OBJ)ProjectNode.imp \
	$(OBJ)ProjectView.imp \
	$(OBJ)Workspace.imp \
	$(if $(WINDOWS),$(OBJ)vsSupport.imp,) \
	$(OBJ)CodeEditor.imp \
	$(OBJ)CodeObject.imp \
	$(OBJ)Designer.imp \
	$(OBJ)findCtx.imp \
	$(OBJ)findExp.imp \
	$(OBJ)findParams.imp \
	$(OBJ)Sheet.imp \
	$(OBJ)ToolBox.imp \
	$(OBJ)debugFindCtx.imp \
	$(OBJ)Debugger.imp \
	$(OBJ)debugTools.imp \
	$(OBJ)GDBDialog.imp \
	$(OBJ)process.imp \
	$(OBJ)BreakpointsView.imp \
	$(OBJ)CallStackView.imp \
	$(OBJ)OutputView.imp \
	$(OBJ)ThreadsView.imp \
	$(OBJ)WatchesView.imp \
	$(OBJ)ModelView.imp \
	$(OBJ)PictureEdit.imp \
	$(OBJ)about.imp \
	$(OBJ)ide.imp \
	$(OBJ)IDESettings.imp \
	$(OBJ)OldIDESettings.imp
IMPORTS2 = \
	$(OBJ)ProjectSettings.imp \
	$(OBJ)licensing.imp

SOURCES = \
	../extras/FileSystemIterator.ec \
	../extras/gui/layout.ec \
	../extras/gui/controls/StringsBox.ec \
	src/dialogs/ActiveCompilerDialog.ec \
	src/dialogs/CompilersDetectionDialog.ec \
	src/dialogs/FindInFilesDialog.ec \
	src/dialogs/GlobalSettingsDialog.ec \
	src/dialogs/NewProjectDialog.ec \
	src/dialogs/NodeProperties.ec \
	src/dialogs/ProjectActiveConfig.ec \
	src/dialogs/WorkspaceSettings.ec \
	src/dialogs/ProjectTabSettings.ec \
	src/project/Project.ec \
	src/project/ProjectConfig.ec \
	src/project/ProjectNode.ec \
	src/project/ProjectView.ec \
	src/project/Workspace.ec \
	$(if $(WINDOWS),src/project/vsSupport.ec,) \
	src/designer/CodeEditor.ec \
	src/designer/CodeObject.ec \
	src/designer/Designer.ec \
	src/designer/findCtx.ec \
	src/designer/findExp.ec \
	src/designer/findParams.ec \
	src/designer/Sheet.ec \
	src/designer/ToolBox.ec \
	src/debugger/debugFindCtx.ec \
	src/debugger/Debugger.ec \
	src/debugger/debugTools.ec \
	src/debugger/GDBDialog.ec \
	src/debugger/process.ec \
	src/panels/BreakpointsView.ec \
	src/panels/CallStackView.ec \
	src/panels/OutputView.ec \
	src/panels/ThreadsView.ec \
	src/panels/WatchesView.ec \
	src/documents/ModelView.ec \
	src/documents/PictureEdit.ec \
	src/about.ec \
	src/ide.ec \
	src/IDESettings.ec \
	src/OldIDESettings.ec \
	src/ProjectSettings.ec \
	src/licensing.ec

RESOURCES = $(RESOURCES1) $(RESOURCES2)
RESOURCES1 = \
	$(RES)actions/attach.png \
	$(RES)actions/delete.png \
	$(RES)actions/detach.png \
	$(RES)actions/docNew.png \
	$(RES)actions/editCopy.png \
	$(RES)actions/editDelete.png \
	$(RES)actions/delete2.png \
	$(RES)actions/build.png \
	$(RES)actions/clean.png \
	$(RES)actions/debug.png \
	$(RES)actions/docOpen.png \
	$(RES)actions/docSave.png \
	$(RES)actions/docSaveAll.png \
	$(RES)actions/pause.png \
	$(RES)actions/projAdd.png \
	$(RES)actions/projNew.png \
	$(RES)actions/projOpen.png \
	$(RES)actions/rebuild.png \
	$(RES)actions/regMakefile.png \
	$(RES)actions/relink.png \
	$(RES)actions/restart.png \
	$(RES)actions/run.png \
	$(RES)actions/skipBreaks.png \
	$(RES)actions/stepInto.png \
	$(RES)actions/stepOut.png \
	$(RES)actions/stepOver.png \
	$(RES)actions/stopDebug.png \
	$(RES)codeMarks/breakpoint.png \
	$(RES)codeMarks/breakpointDisabled.png \
	$(RES)codeMarks/breakpointHalf.png \
	$(RES)codeMarks/breakpointHalfDisabled.png \
	$(RES)codeMarks/cursor.png \
	$(RES)codeMarks/cursorError.png \
	$(RES)codeMarks/topFrame.png \
	$(RES)codeMarks/topFrameError.png \
	$(RES)codeMarks/topFrameHalf.png \
	$(RES)codeMarks/topFrameHalfError.png \
	$(RES)others/mousePointer.png \
	locale/zh_CN/LC_MESSAGES/ide.mo \
	locale/es_ES/LC_MESSAGES/ide.mo \
	../LICENSE \
	../extras/res/licenses/png.LICENSE \
	../extras/res/licenses/tango.COPYING \
	../extras/res/licenses/zlib.README \
	../extras/res/licenses/sqlite.LICENSE \
	../extras/res/licenses/jpg.LICENSE \
	../extras/res/licenses/ungif.LICENSE \
	../extras/res/licenses/freetype.LICENSE
RESOURCES2 = \
	../extras/res/licenses/harfbuzz.LICENSE \
	../extras/res/licenses/upx.LICENSE \
	../extras/res/licenses/gpl.LICENSE \
	res/ecere.jpg \
	res/ecereBack.jpg \
	res/icon.png \
	../include.mk \
	../crossplatform.mk

ifndef DEBIAN_PACKAGE
CFLAGS =
endif
OFLAGS =

# CROSS-PLATFORM MAGIC

include ../include.mk

# TOOLCHAIN
export LD_LIBRARY_PATH = ../obj/$(PLATFORM)/lib/
export DYLD_LIBRARY_PATH = ../obj/$(PLATFORM)/lib/
ECP := $(call psep,../obj/$(PLATFORM)/bin/ecp)
ECC := $(call psep,../obj/$(PLATFORM)/bin/ecc)
ECS := $(call psep,../obj/$(PLATFORM)/bin/ecs)
EAR := $(call psep,../obj/$(PLATFORM)/bin/ear)

# FLAGS

CFLAGS += -fmessage-length=0 -O2 -ffast-math -m32 $(FPIC) -w

CECFLAGS =

ECFLAGS = -nolinenumbers

OFLAGS += -m32 \
	 -L../obj/$(PLATFORM)/bin \
	 -L../obj/$(PLATFORM)/lib

LIBS = -lecere $(SHAREDLIB) $(EXECUTABLE) $(LINKOPT)

UPXFLAGS = -9 -q

# HARD CODED PLATFORM-SPECIFIC OPTIONS
ifdef LINUX
OFLAGS += -Wl,--no-undefined
endif

# PLATFORM-SPECIFIC OPTIONS

ifdef WINDOWS

LIBS += obj/resources.o

else
ifdef LINUX

OFLAGS += \
	 -L/usr/X11R6/lib

LIBS += -lX11

else
ifdef OSX

OFLAGS += \
	 -L/usr/X11R6/lib

LIBS += -lX11

endif
endif
endif

# TARGETS

all: objdir $(TARGET)

objdir:
	$(if $(wildcard $(OBJ)),,$(call mkdirq,$(OBJ)))

$(OBJ)$(MODULE).main.ec: $(SYMBOLS) $(COBJECTS)
	$(ECS) $(ECSLIBOPT) $(SYMBOLS) $(IMPORTS) -symbols obj/$(CONFIG).$(PLATFORM) -o $(OBJ)$(MODULE).main.ec

$(OBJ)$(MODULE).main.c: $(OBJ)$(MODULE).main.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c $(OBJ)$(MODULE).main.ec -o $(OBJ)$(MODULE).main.sym -symbols $(OBJ)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)$(MODULE).main.ec -o $(OBJ)$(MODULE).main.c -symbols $(OBJ)

$(SYMBOLS): | objdir
$(OBJECTS): | objdir
$(TARGET): $(SOURCES) $(RESOURCES) $(SYMBOLS) $(OBJECTS) | objdir
ifdef WINDOWS
$(TARGET): obj/resources.o
endif
	$(CC) $(OFLAGS) $(OBJECTS) $(LIBS) -o $(TARGET) $(INSTALLNAME)
ifndef NOSTRIP
	$(STRIP) $(STRIPOPT) $(TARGET)
endif
	$(EAR) awq $(TARGET) res/ecere.jpg res/ecereBack.jpg res/icon.png ../include.mk ../crossplatform.mk ""
	$(EAR) awq $(TARGET) $(RES)actions/attach.png $(RES)actions/delete.png $(RES)actions/detach.png $(RES)actions/docNew.png $(RES)actions/editCopy.png $(RES)actions/editDelete.png $(RES)actions/delete2.png $(RES)actions/build.png $(RES)actions/clean.png $(RES)actions/debug.png "actions"
	$(EAR) awq $(TARGET) $(RES)actions/docOpen.png $(RES)actions/docSave.png $(RES)actions/docSaveAll.png $(RES)actions/pause.png $(RES)actions/projAdd.png $(RES)actions/projNew.png $(RES)actions/projOpen.png $(RES)actions/rebuild.png $(RES)actions/regMakefile.png $(RES)actions/relink.png "actions"
	$(EAR) awq $(TARGET) $(RES)actions/restart.png $(RES)actions/run.png $(RES)actions/skipBreaks.png $(RES)actions/stepInto.png $(RES)actions/stepOut.png $(RES)actions/stepOver.png $(RES)actions/stopDebug.png "actions"
	$(EAR) awq $(TARGET) $(RES)codeMarks/breakpoint.png $(RES)codeMarks/breakpointDisabled.png $(RES)codeMarks/breakpointHalf.png $(RES)codeMarks/breakpointHalfDisabled.png $(RES)codeMarks/cursor.png $(RES)codeMarks/cursorError.png $(RES)codeMarks/topFrame.png $(RES)codeMarks/topFrameError.png $(RES)codeMarks/topFrameHalf.png $(RES)codeMarks/topFrameHalfError.png "codeMarks"
	$(EAR) awq $(TARGET) $(RES)others/mousePointer.png "others"
	$(EAR) awq $(TARGET) locale/zh_CN/LC_MESSAGES/ide.mo "locale/zh_CN/LC_MESSAGES"
	$(EAR) awq $(TARGET) locale/es_ES/LC_MESSAGES/ide.mo "locale/es_ES/LC_MESSAGES"
	$(EAR) awq $(TARGET) ../LICENSE ../extras/res/licenses/png.LICENSE ../extras/res/licenses/tango.COPYING ../extras/res/licenses/zlib.README ../extras/res/licenses/sqlite.LICENSE ../extras/res/licenses/jpg.LICENSE ../extras/res/licenses/ungif.LICENSE ../extras/res/licenses/freetype.LICENSE ../extras/res/licenses/harfbuzz.LICENSE ../extras/res/licenses/upx.LICENSE "licenses"
	$(EAR) awq $(TARGET) ../extras/res/licenses/gpl.LICENSE "licenses"
	$(call cpq,$(TARGET),../obj/$(PLATFORM)/bin/)

ifdef WINDOWS
obj/resources.o: src/icon2.ico src/resources.rc | objdir
	windres src/resources.rc obj/resources.o
endif

# SYMBOL RULES

$(OBJ)FileSystemIterator.sym: ../extras/FileSystemIterator.ec
