=== debian/changelog ===
ecere-sdk (0.44.01-1) experimental; urgency=low

  * Initial packaging of Ecere SDK for Debian. (Closes: #665332, LP: #394998)

 -- Jerome St-Louis <jerstlouis@gmail.com>  Tue, 14 Aug 2012 06:58:00 -0400
