=== debian/watch ===
version=3
https://github.com/ecere/sdk/tags .*/tarball/(\d[\d\.]+)
